Bug 902017 - Review Request: openshift-java-client - OpenShift Java Client
Review Request: openshift-java-client - OpenShift Java Client
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tomas Radej
Fedora Extras Quality Assurance
:
Depends On: 917656
Blocks:
  Show dependency treegraph
 
Reported: 2013-01-20 08:29 EST by Gerard Ryan
Modified: 2013-05-01 17:58 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-04-27 23:47:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tradej: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker JBIDE-13812 Major Closed openshift-java-client: get rid of external class to (de)code base64 2013-10-20 18:53:57 EDT

  None (edit)
Description Gerard Ryan 2013-01-20 08:29:56 EST
Spec URL: http://galileo.fedorapeople.org/openshift-java-client/openshift-java-client.spec
SRPM URL: http://galileo.fedorapeople.org/openshift-java-client/openshift-java-client-2.0.3-1.20130120gitef1e48d.fc18.src.rpm

Description:
This is a client for OpenShift written in java. It pretty much offers all
features that are currently available in the rhc-* command line tools
(create/rename a domain, create/destroy applications, list all existing
applications, available cartridges, embed cartridges etc.).

Fedora Account System Username: galileo
Comment 1 Tomas Radej 2013-02-15 04:53:31 EST
I'll do it.
Comment 2 Tomas Radej 2013-02-27 12:10:05 EST
Hi, there are some licensing problems with this package - POM file declares the license to be ASL 2.0, but the ./license file and most of the files say EPL, Base64Coder is a class available in the base64coder package already in Fedora etc., so I will talk to upstream (I am a Red Hat employee) to correct this before I proceed with the review.
Comment 3 Gerard Ryan 2013-03-17 11:49:50 EDT
Hi, Tomas, any update on this? I was without a net connection for the past few weeks so I couldn't check up anything with it. For some reason I don't seem to be able to access bug #917656 that this has been marked dependent on, is that intentional?
Comment 4 Tomas Radej 2013-03-18 09:50:46 EDT
Hi, the blocking bug was private by mistake. It is viewable now. I am sorry for the inconvenience.
Comment 5 Gerard Ryan 2013-03-18 10:33:17 EDT
No problem, I figured it was accidental :) Thanks.
Comment 6 Gerard Ryan 2013-03-18 15:29:44 EDT
Licensing problem fixed upstream. I've also just submitted a pull request to unbundle base64coder: https://github.com/openshift/openshift-java-client/pull/32

If/when that gets merged, I'll update the spec and srpm here, and we'll see if we can get any further along with this. :)
Comment 7 Andre Dietisheim 2013-03-19 06:59:50 EDT
Hi Gerard

thanks for pointing this out and replacing the forked version by a proper maven dependency. Nevertheless one important goal in the openshift-java-client is to have as little 3rd party dependencies as possible. Deep diving into this issue made me find a way to use JDK means to decode/encode base64 rather than relying on an external class. I'll therefore reject your pull-request and correct openshift-java-client to use the jdk for the (de)coding.
Comment 8 Andre Dietisheim 2013-03-19 07:08:59 EDT
I filed this to our JIRA in https://issues.jboss.org/browse/JBIDE-13812 so that we can easily keep track of it. Can you please add this reference to the jboss issue tracker (I cannot) so that we get updates to this bugzilla in our issue?
Comment 9 Andre Dietisheim 2013-03-19 11:42:23 EDT
I fixed the issue by using the JDK means to decode/encode base64 rather uisng the external class:

https://github.com/openshift/openshift-java-client/pull/33

patch was pushed to master
Comment 10 Gerard Ryan 2013-03-20 04:55:08 EDT
Even better! :) Thanks for that André. I'll update this package proposal after work today then.
Comment 11 Andre Dietisheim 2013-03-20 05:46:43 EDT
great, thanks :)
Comment 12 Gerard Ryan 2013-03-20 19:42:26 EDT
Spec URL: http://galileo.fedorapeople.org/openshift-java-client/2.0.3-2/openshift-java-client.spec
SRPM URL: http://galileo.fedorapeople.org/openshift-java-client/2.0.3-2/openshift-java-client-2.0.3-2.20130320git7073708.fc18.src.rpm

Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5150244
(license tag in spec is wrong for this build, but is correct for the spec/srpm above)

- Updated to include all the changes that have happened upstream
-- Licensing fixed.
-- André has removed the bundled Base64Coder class

- Updated to use new maven macros.
Comment 13 Gerard Ryan 2013-03-20 19:43:32 EDT
I think it's ready now Tomas, please have a look when you get a chance, thanks! :)
Comment 14 Tomas Radej 2013-03-28 13:02:08 EDT
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======

[!]: Changelog in prescribed format.
>>>> There must either be a space on both sides of the delimiting dash, or
>>>> no delimiting dash at all. I. e.
>>>>   ...t.org> - 2.0.3-2 
>>>> or 
>>>>   ...t.org> 2.0.3-2

[!]: Package complies to the Packaging Guidelines
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
>>>> you should include 
>>>>   %doc license epl-v10.html
>>>> in %files and %files javadoc

Notes:
======

[!]: Requires correct, justified where necessary.
>>>> You don't need to specify Requires when building with %mvn_build

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Package complies to the Packaging Guidelines
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 2 files have unknown license.
     Detailed output of licensecheck in /home/tradej/reviews/openshift-java-
     client/review-openshift-java-client/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Java:
[x]: Fully versioned dependency in subpackages, if present.
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Java:
[x]: Package has BuildArch: noarch (if possible)
[x]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: openshift-java-client-2.0.3-2.20130320git7073708.fc20.noarch.rpm
openshift-java-client.noarch: W: spelling-error %description -l en_US rhc -> rec, rho, Rh
openshift-java-client.noarch: W: incoherent-version-in-changelog -2.0.3-2 ['2.0.3-2.20130320git7073708.fc20', '2.0.3-2.20130320git7073708']
openshift-java-client.noarch: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint openshift-java-client
openshift-java-client.noarch: W: spelling-error %description -l en_US rhc -> rec, rho, Rh
openshift-java-client.noarch: W: incoherent-version-in-changelog -2.0.3-2 ['2.0.3-2.20130320git7073708.fc20', '2.0.3-2.20130320git7073708']
openshift-java-client.noarch: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
openshift-java-client (rpmlib, GLIBC filtered):
    java
    jpackage-utils
    jsch
    mvn(com.jcraft:jsch)
    mvn(commons-io:commons-io)
    mvn(log4j:log4j)
    mvn(org.codehaus.mojo:properties-maven-plugin)
    mvn(org.jboss:jboss-dmr)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-log4j12)



Provides
--------
openshift-java-client:
    mvn(com.openshift:openshift-java-client)
    openshift-java-client



MD5-sum check
-------------
https://github.com/openshift/openshift-java-client/archive/707370873280180663c7b4c8730c25db408ee624/openshift-java-client-2.0.3-7073708.tar.gz :
  CHECKSUM(SHA256) this package     : ea92722842c72f7898a8171c204e652c21d0d694c593d8cce05295c574596b0c
  CHECKSUM(SHA256) upstream package : ea92722842c72f7898a8171c204e652c21d0d694c593d8cce05295c574596b0c


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -n openshift-java-client -m fedora-rawhide-x86_64


*** NOT APPROVED ***

Issues described at the top of this comment.
Comment 15 Gerard Ryan 2013-03-29 21:05:53 EDT
(In reply to comment #14)
> Package Review
> ==============
> 
> Key:
> [x] = Pass
> [!] = Fail
> [-] = Not applicable
> [?] = Not evaluated
> [ ] = Manual review needed
> 
> 
> Issues:
> =======
> 
> [!]: Changelog in prescribed format.
> >>>> There must either be a space on both sides of the delimiting dash, or
> >>>> no delimiting dash at all. I. e.
> >>>>   ...t.org> - 2.0.3-2 
> >>>> or 
> >>>>   ...t.org> 2.0.3-2

Fixed.

> [!]: Package complies to the Packaging Guidelines
> [!]: If (and only if) the source package includes the text of the license(s)
>      in its own file, then that file, containing the text of the license(s)
>      for the package is included in %doc.
> >>>> you should include 
> >>>>   %doc license epl-v10.html
> >>>> in %files and %files javadoc

Oops. I don't know how that got removed, thanks for pointing it out. Fixed.

> Notes:
> ======
> 
> [!]: Requires correct, justified where necessary.
> >>>> You don't need to specify Requires when building with %mvn_build

Fixed. I've left in Requires on jsch since it doesn't have a maven POM.


DIFF of specfile since previous uploaded version
===========================================================
@@ -4,7 +4,7 @@
 
 Name:           openshift-java-client
 Version:        2.0.3
-Release:        2.%{checkout}%{?dist}
+Release:        3.%{checkout}%{?dist}
 Summary:        OpenShift Java Client
 
 Group:          Development/Libraries
@@ -13,7 +13,6 @@ URL:            http://openshift.redhat.com
 Source0:        https://github.com/openshift/%{name}/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
 BuildArch: noarch
 
-BuildRequires: java-devel
 BuildRequires: maven-local
 BuildRequires: jsch
 BuildRequires: mvn(org.easytesting:fest-assert)
@@ -25,11 +24,6 @@ BuildRequires: mvn(log4j:log4j)
 BuildRequires: mvn(org.codehaus.mojo:properties-maven-plugin)
 BuildRequires: mvn(commons-io:commons-io)
 Requires: jsch
-Requires: mvn(org.jboss:jboss-dmr)
-Requires: mvn(org.slf4j:slf4j-log4j12)
-Requires: mvn(commons-io:commons-io)
-Requires: mvn(org.codehaus.mojo:properties-maven-plugin)
-Requires: java
 
 %description
 This is a client for OpenShift written in java. It pretty much offers all
@@ -57,13 +51,20 @@ API documentation for %{name}.
 
 %files -f .mfiles
 %dir %{_javadir}/%{name}
+%doc license epl-v10.html
 
 %files javadoc -f .mfiles-javadoc
+%doc license epl-v10.html
 
 %changelog
-* Wed Mar 20 2013 Gerard Ryan <galileo@fedoraproject.org> -2.0.3-2
+* Fri Mar 29 2013 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-3
+- Fix changelog.
+- Remove unneeded Requires.
+- Added epl-v10.html as a doc to main and javadoc packages.
+
+* Wed Mar 20 2013 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-2
 - Update to fix licensing and new Base64Coder implementation.
 - Use new maven macros.
 
-* Sun Jan 20 2013 Gerard Ryan <galileo@fedoraproject.org> -2.0.3-1 
+* Sun Jan 20 2013 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-1
 - Initial package.

=========================================================================

Spec URL: http://galileo.fedorapeople.org/openshift-java-client/2.0.3-3/openshift-java-client.spec
SRPM URL: http://galileo.fedorapeople.org/openshift-java-client/2.0.3-3/openshift-java-client-2.0.3-3.20130320git7073708.fc18.src.rpm
Comment 16 Tomas Radej 2013-04-22 04:31:06 EDT
Sorry for the delay. The package is good to go.

*** APPROVED ***
Comment 17 Gerard Ryan 2013-04-22 14:15:05 EDT
(In reply to comment #16)
> Sorry for the delay. The package is good to go.
> 
> *** APPROVED ***

Thanks a lot! :)
Comment 18 Gerard Ryan 2013-04-22 14:16:56 EDT
New Package SCM Request
=======================
Package Name: openshift-java-client
Short Description: OpenShift Java Client
Owners: galileo
Branches: f19, f18
InitialCC:
Comment 19 Gwyn Ciesla 2013-04-22 14:31:22 EDT
Git done (by process-git-requests).
Comment 20 Fedora Update System 2013-04-22 17:27:29 EDT
openshift-java-client-2.0.3-3.20130320git7073708.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/openshift-java-client-2.0.3-3.20130320git7073708.fc19
Comment 21 Fedora Update System 2013-04-22 23:02:49 EDT
openshift-java-client-2.0.3-3.20130320git7073708.fc19 has been pushed to the Fedora 19 testing repository.
Comment 22 Fedora Update System 2013-04-27 23:47:23 EDT
openshift-java-client-2.0.3-3.20130320git7073708.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.